=== debian/changelog ===
macaulay2 (1.23+ds-2build1) oracular; urgency=medium

  * No-change rebuild against libflint19

 -- Simon Chopin <ravi.kant.sharma@canonical.com>  Tue, 14 May 2024 10:38:25 +0200

macaulay2 (1.23+ds-2) unstable; urgency=medium

  * debian/patches/skip-failing-package-tests.patch
    - Skip RInterface tests that are failing on riscv64 and loongarch64.

 -- Doug Torrance <dtorrance@debian.org>  Thu, 04 Apr 2024 23:18:37 -0400

macaulay2 (1.23+ds-1) unstable; urgency=medium

  * New upstream release.
  * debian/control
    - Move normaliz from Recommends to Depends; now loaded on startup.

 -- Doug Torrance <dtorrance@debian.org>  Wed, 20 Mar 2024 06:18:28 -0400

macaulay2 (1.23~rc1+ds-1) experimental; urgency=medium

  * New upstream release candidate.
  * debian/control
    - Remove libatomic-ops-dev from Build-Depends; no longer necessary.
    - Replace deprecated pkg-config with pkgconf in Build-Depends.
    - Add r-base to Build-depends and Suggests.
  * debian/copyright
    - Bump my copyright years
    - Remove atomic_ops-related files.
    - Add license info for new packages.
    - Update Files for documentation moved from Macaulay2Doc to Varieties
      package.
  * debian/macaulay2-common.lintian-overrides
    - Shorten override comment to avoid wrapping in terminal.
    - Add new package-contains-documentation-outside-user-share-doc
      overrides.
  * debian/patches
    - Refresh patches for new upstream release.
    - Remove patches applied upstream:
      + boost-thread.patch
      + flint3.patch
      + python-3.12.patch
  * debian/patches/no-version-select.patch
    - New package; disable version-select dropdown menu in html
      documentation.
  * debian/patches/skip-failing-package-tests.patch
    - Skip some Topcom and Triangulations package tests that frequently
      fail on arm and s390x machines.
  * debian/patches/topcom-memopt.patch
    - Add --memopt option in several more calls to TOPCOM.
  * debian/patches/use-dh-elpa.patch
    - Rewrite setupEmacs so M2 major modes will properly load even if Emacs
      isn't the Debian-packaged version.
  * debian/rules
    - Exclude .uuid files from dh_linktree; their presence was
      occasionally causing build failures.
  * debian/scripts/Debian.m2
    - Add ExampleFreeResolutions package to list of packages to skip in
      missingPackages function.
  * debian/README.Debian
    - Add r-base to "Suggested packages" section.

 -- Doug Torrance <dtorrance@debian.org>  Sat, 02 Mar 2024 21:43:15 -0500

macaulay2 (1.22+ds-6) unstable; urgency=medium

  * debian/copyright
    - Update copyright years for gmpy2 code.
  * debian/patches/python-3.12.patch
    - New patch; add support for Python 3.12 (Closes:  #1061313).

 -- Doug Torrance <dtorrance@debian.org>  Mon, 22 Jan 2024 10:17:56 -0500

macaulay2 (1.22+ds-5) unstable; urgency=medium

  * debian/patches/boost-thread.patch
    - New patch; disable thread safety for Boost if no atomic ints or
      std::mutex. Fixes armel build with Boost 1.83.

 -- Doug Torrance <dtorrance@debian.org>  Tue, 19 Dec 2023 17:26:50 -0500
